
<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

    <title>Version 2.3.0 &#8212; IMAPClient 2.3.1 documentation</title>
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/sphinxdoc.css" />
    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
    <script src="_static/doctools.js"></script>
    <link rel="search" title="Search" href="search.html" />
    <link rel="prev" title="Contributing to IMAPClient" href="contributing.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a></li>
        <li class="right" >
          <a href="contributing.html" title="Contributing to IMAPClient"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">IMAPClient 2.3.1 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Version 2.3.0</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="version-2-3-0">
<h1>Version 2.3.0<a class="headerlink" href="#version-2-3-0" title="Permalink to this heading">¶</a></h1>
<p><strong>Note</strong>: This will be the last release to support Python 2.</p>
<p>Many thanks to Boni Lindsley for many of the changes in this release. Changes
below are by them unless otherwise specified.</p>
<section id="changed">
<h2>Changed<a class="headerlink" href="#changed" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Use GitHub Actions instead of TravisCI</p></li>
<li><p>Improvements to code examples (thanks shoaib30)</p></li>
<li><p>Run tests with unittest instead of setup.py</p></li>
</ul>
</section>
<section id="added">
<h2>Added<a class="headerlink" href="#added" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>New <code class="docutils literal notranslate"><span class="pre">socket()</span></code> method which provides access to the underlying network
socket. This is useful for allowing the socket to be polled.</p></li>
<li><p>Allow flags and internaldate to be specified for MULTIAPPEND (thanks Tobias Kölling)</p></li>
</ul>
</section>
<section id="fixed">
<h2>Fixed<a class="headerlink" href="#fixed" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Default SSL contexts are now created with correct purpose (thanks pinoatrome)</p></li>
<li><p>Fixed undiscoverable tests due to name shadowing</p></li>
<li><p>Fixed missing code block directives in documentation</p></li>
<li><p>Fixed typo in tox envlist</p></li>
<li><p>Fixed formatting in release notes</p></li>
</ul>
</section>
</section>
<section id="version-2-2-0">
<h1>Version 2.2.0<a class="headerlink" href="#version-2-2-0" title="Permalink to this heading">¶</a></h1>
<section id="id1">
<h2>Changed<a class="headerlink" href="#id1" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Performance improvements (thanks Carson Ip!)</p>
<ul>
<li><p>2x faster _maybe_int_to_bytes for Python 2 (#375)</p></li>
<li><p>Fix _proc_folder_list quadratic runtime (#374)</p></li>
<li><p>Faster utf7 encode (#373). ~40% faster for input with a mix of unicode and
ASCII chars.</p></li>
<li><p>Cache regex in _process_select_response</p></li>
</ul>
</li>
<li><p>poll() when available to surpass 1024 file descriptor limit with select() (#377) (thanks Jonny Hatch)</p></li>
<li><p>Use next instead of six.next as imapclient doesn’t claim Python 2.5 support. (#396) (thanks Jasper Spaans)</p></li>
<li><p>Moved “Logged in/out” traces from INFO to DEBUG level (thanks Fabio Manganiello)</p></li>
<li><p>Run tests on Python 3.8 and 3.9</p></li>
<li><p>Support the Deleted special folder used by Outlook (thanks Samir M)</p></li>
<li><p>Clean up timeout handling</p></li>
<li><p>Run the Black code formatter over the entire project</p></li>
</ul>
</section>
<section id="id2">
<h2>Added<a class="headerlink" href="#id2" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>MULTIAPPEND and LITERAL+ support (#399) (thanks Devin Bayer)</p></li>
<li><p>Use ptpython for interactive shell if available (#272)</p></li>
<li><p>Allow any custom SASL mechanism to be provided. This allows mechanisms such
as EXTERNAL, GSSAPI or SCRAM-SHA-256 to be used in the same way as with
imaplib. (thanks Mantas Mikulėnas)</p></li>
<li><p>Add SASL OAUTHBEARER support</p></li>
<li><p>add optional timeout parameter to IMAP4_TLS.open (thanks zrose584)</p></li>
</ul>
</section>
<section id="id3">
<h2>Fixed<a class="headerlink" href="#id3" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>fixed special folder searching</p></li>
<li><p>Catch the right exception in folder_status (#371)</p></li>
<li><p>test_imapclient: Fix LoggerAdapter version check (#383) (thanks Michał Górny)</p></li>
<li><p>Fix config file parsing for None attributes (#393) (thanks François Deppierraz)</p></li>
<li><p>Fix useless ref cycle in lexer</p></li>
<li><p>Protocol parsing: Prevent converting numbers with leading zeroes to int. (#390) (#405) (thanks Jasper Spaans)</p></li>
<li><p>Prevent UnicodeDecodeError in IMAPlibLoggerAdapter (#367)</p></li>
<li><p>Fix invalid string escape sequences (#397)</p></li>
<li><p>Ensure timeout is used on Python 2.7.  _create_socket isn’t used with the
Python 2 version of imaplib so the open method has been overrided to make it
consistent across Python version (#380).</p></li>
<li><p>Fix IMAP4_TLS for imaplib in Python 3.9+ (thanks Christopher Arndt, marmarek and link2xt)</p></li>
</ul>
</section>
</section>
<section id="version-2-1-0">
<h1>Version 2.1.0<a class="headerlink" href="#version-2-1-0" title="Permalink to this heading">¶</a></h1>
<section id="id4">
<h2>Changed<a class="headerlink" href="#id4" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>TravisCI now runs tests against PyPy</p></li>
<li><p>Python 3.7 is now officially supported</p></li>
<li><p>Cleaned up server capability checks</p></li>
<li><p>Use TLS by default for interactive sessions</p></li>
</ul>
</section>
<section id="id5">
<h2>Added<a class="headerlink" href="#id5" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Support the <code class="docutils literal notranslate"><span class="pre">QUOTA</span></code> extension</p></li>
<li><p>Support for locating special folders (<code class="docutils literal notranslate"><span class="pre">find_special_folder()</span></code>)</p></li>
<li><p>Document usage of client TLS certificates</p></li>
<li><p>Added documentation &amp; example for parsing retrieved emails using the
standard library <code class="docutils literal notranslate"><span class="pre">email</span></code> package.</p></li>
</ul>
</section>
<section id="id6">
<h2>Fixed<a class="headerlink" href="#id6" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Handle <code class="docutils literal notranslate"><span class="pre">NIL</span></code> values for <code class="docutils literal notranslate"><span class="pre">INTERNALDATE</span></code></p></li>
</ul>
</section>
</section>
<section id="version-2-0">
<h1>Version 2.0<a class="headerlink" href="#version-2-0" title="Permalink to this heading">¶</a></h1>
<section id="id7">
<h2>Changed<a class="headerlink" href="#id7" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Only use Python’s built-in TLS support (no more backports.ssl &amp; pyOpenSSL)</p></li>
<li><p>Connections use SSL/TLS by default (<cite>ssl=True</cite>)</p></li>
<li><p>Drop <code class="docutils literal notranslate"><span class="pre">imapclient.tls.create_default_context</span></code> function. In case you were
using it, you can use the method with the same name available in the
built-in <code class="docutils literal notranslate"><span class="pre">ssl</span></code> module.</p></li>
<li><p>Logs are now handled by the Python logging module. The <cite>debug</cite> and <cite>log_file</cite>
attributes are gone.</p></li>
<li><p>More precise exceptions available in <cite>imapclient.exceptions</cite> are raised when
an error happens</p></li>
<li><p><cite>imapclient.exceptions.ProtocolError</cite> is now raised when the reply from a
remote server violates the IMAP protocol.</p></li>
<li><p>SEARCH exceptions now link to relevant documentation.</p></li>
<li><p>GMail labels are now strings instead of bytes in Python 3.</p></li>
<li><p>OAUTH v1 support removed.</p></li>
<li><p>setup.py has been simplified.</p></li>
<li><p>All non-library code moved out of the <cite>imapclient</cite> package.</p></li>
<li><p>Many documentation improvements.</p></li>
</ul>
</section>
<section id="id8">
<h2>Added<a class="headerlink" href="#id8" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Connection and read/write operations timeout can now be distinct, using
<cite>imapclient.SocketTimeout</cite> namedtuple as <cite>timeout</cite> parameter.</p></li>
<li><p>A context manager is introduced to automatically close connections to remote
servers.</p></li>
<li><p>EXPUNGE by ID support.</p></li>
<li><p>ENABLE support.</p></li>
<li><p>UNSELECT support.</p></li>
<li><p>Atomically move messages to another folder using the MOVE extension
(<span class="target" id="index-0"></span><a class="rfc reference external" href="https://datatracker.ietf.org/doc/html/rfc6851.html"><strong>RFC 6851</strong></a>)</p></li>
<li><p>New <cite>welcome</cite> property to allow access to IMAP server greeting.</p></li>
</ul>
</section>
<section id="id9">
<h2>Fixed<a class="headerlink" href="#id9" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>GMail labels using international characters are now handled properly.</p></li>
<li><p>Don’t use locale dependent formatting in <cite>datetime_to_INTERNAL_DATE()</cite>.</p></li>
<li><p>Quote empty strings to prevent syntax errors while SEARCHing for zero-length
strings.</p></li>
<li><p>Handle address without mailbox name or host in Address namedtuple.</p></li>
<li><p>Avoid asserts in response parsing codes to allow graceful recovery.</p></li>
<li><p>Prevent logging of IMAP passwords.</p></li>
</ul>
</section>
<section id="python-compatibility">
<h2>Python compatibility<a class="headerlink" href="#python-compatibility" title="Permalink to this heading">¶</a></h2>
<p>Support for Python 2.6 and 3.3 is removed in this release.</p>
<p>This version supports Python 2.7, 3.4, 3.5 and 3.6. We officially support the
latest release of each series.</p>
</section>
</section>
<section id="version-1-1-0">
<h1>Version 1.1.0<a class="headerlink" href="#version-1-1-0" title="Permalink to this heading">¶</a></h1>
<section id="id10">
<h2>Added<a class="headerlink" href="#id10" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Search now supports nested criteria so that more complex criteria
can be expressed. IMAPClient will add parentheses in the right place.</p></li>
<li><p>PLAIN authentication support (via <cite>plain_login</cite> method)</p></li>
<li><p><cite>unselect_folder()</cite> method, for servers with the UNSELECT capability (#200)</p></li>
<li><p>Add ENABLE support (#136)</p></li>
<li><p>UID EXPUNGE support (#287)</p></li>
</ul>
</section>
<section id="id11">
<h2>Changed<a class="headerlink" href="#id11" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>the <cite>mock</cite> package is no longer installed by default (just as a test
dependency)</p></li>
<li><p>handle NIL date values in INTERNALDATE</p></li>
<li><p>add <cite>silent</cite> option to all flags methods (improves performance by
avoiding unnecessary parsing)</p></li>
<li><p>simplify Gmail label functionality</p></li>
<li><p>folder_status is more robust</p></li>
<li><p>various livetest reliability improvements</p></li>
</ul>
</section>
<section id="id12">
<h2>Fixed<a class="headerlink" href="#id12" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>don’t quote search criteria when sent as IMAP literals. Fixes #249.</p></li>
<li><p>Modified UTF-7 encoding function had quirks in its original algorithm,
leading to incorrect encoded output in some cases. The algorithm, described
in RFC 3501, has been reimplemented to fix #187 and is better documented.</p></li>
<li><p>use fixed month names when formatting INTERNALDATES (don’t rely on locale)</p></li>
<li><p>handle address without mailbox name or host in Address namedtuple. Fixes #242.</p></li>
<li><p>Use cryptography &lt; 2.0 on Python 3.3. Fixes #305.</p></li>
</ul>
</section>
</section>
<section id="version-1-0-2">
<h1>Version 1.0.2<a class="headerlink" href="#version-1-0-2" title="Permalink to this heading">¶</a></h1>
<section id="new">
<h2>New<a class="headerlink" href="#new" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Documented the livetest/interact INI file format.</p></li>
<li><p>Documented handling of RFC2822 group syntax.</p></li>
</ul>
</section>
<section id="id13">
<h2>Changed<a class="headerlink" href="#id13" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Explicitly check that the required pyOpenSSL version is installed</p></li>
<li><p>Start testing against Python 3.5</p></li>
<li><p>Update doc links from readthedocs.org to readthedocs.io</p></li>
<li><p>Rearranged README so that project essentials are right at the top.</p></li>
</ul>
</section>
<section id="id14">
<h2>Fixed<a class="headerlink" href="#id14" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Allow installation from alternate directories</p></li>
</ul>
</section>
</section>
<section id="version-1-0-1">
<h1>Version 1.0.1<a class="headerlink" href="#version-1-0-1" title="Permalink to this heading">¶</a></h1>
<section id="id15">
<h2>Changed<a class="headerlink" href="#id15" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Minimum backports.ssl dependency is now 0.0.9 (an important
performance issue was addressed)</p></li>
<li><p>setuptools 18.8.1 now used due to strange zip file error for 17.1</p></li>
</ul>
</section>
<section id="id16">
<h2>Fixed<a class="headerlink" href="#id16" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Unit test for version strings were updated to now always include the
patch version.</p></li>
<li><p>Fresh capabilities now retrieved between STARTTLS and authentication
(#195).</p></li>
</ul>
</section>
</section>
<section id="version-1-0-0">
<h1>Version 1.0.0<a class="headerlink" href="#version-1-0-0" title="Permalink to this heading">¶</a></h1>
<section id="enhanced-tls-support-api">
<h2>Enhanced TLS support [API]<a class="headerlink" href="#enhanced-tls-support-api" title="Permalink to this heading">¶</a></h2>
<p>The way that IMAPClient establishes TLS/SSL connections has been
completely reworked. By default IMAPClient will attempt certificate
verification, certificate hostname checking, and will not use
known-insecure TLS settings and protocols. In addition, TLS parameters
are now highly configurable.</p>
<p>By leveraging pyOpenSSL and backports.ssl, all Python versions
supported by IMAPClient enjoy the same TLS functionality and
API.</p>
<p>These packages mean that IMAPClient now has a number of new
dependencies. These should be installed automatically as required but
there will no doubt be complications.</p>
<p>Compatibility breaks:</p>
<ol class="arabic simple">
<li><p>Due to lack of support in some of the dependent libraries,
IMAPClient no longer supports Python 3.2.</p></li>
<li><p>The passthrough keyword arguments that the IMAPClient constructor
took in past versions are no longer accepted. These were in place
to provide access to imaplib’s SSL arguments which are no longer
relevant. Please pass a SSL context object instead.</p></li>
<li><p>When using the default SSL context that IMAPClient creates
(recommended), certificate verification is enabled. This means that
IMAPClient connections to servers that used to work before,
may fail now (especially if a self-signed certificate is used by
the server). Refer to the documentation for details of how to
supply alternate CA certificates or disable verification.</p></li>
<li><p>There are some new exceptions that might be raised in response to
network issues or TLS protocol failures. Refer to the
<a class="reference external" href="http://imapclient.readthedocs.io/en/latest/#exceptions">Exceptions</a> section of the manual for more details.</p></li>
</ol>
<p>Please refer to the “TLS/SSL” section of the manual for more details
on all of the above.</p>
<p>Many thanks to Chris Arndt and Marc-Antoine Parent for their input
into these TLS improvements.</p>
</section>
<section id="starttls-support-new">
<h2>STARTTLS support [NEW]<a class="headerlink" href="#starttls-support-new" title="Permalink to this heading">¶</a></h2>
<p>When the server supports it, IMAPClient can now establish an encrypted
connection after initially starting with an unencrypted connection
using the STARTTLS command. The starttls method takes an SSL context
object for controlling the parameters of the TLS negotiation.</p>
<p>Many thanks to Chris Arndt for his extensive initial work on this.</p>
</section>
<section id="more-robust-criteria-handling-for-search-sort-and-thread-api">
<h2>More robust criteria handling for search, sort and thread [API]<a class="headerlink" href="#more-robust-criteria-handling-for-search-sort-and-thread-api" title="Permalink to this heading">¶</a></h2>
<p>IMAPClient’s methods that accept search criteria (search, sort,
thread, gmail_search) have been changed to provide take criteria in
a more straightforward and robust way. In addition, the way the
<em>charset</em> argument interacts with search criteria has been
improved. These changes make it easier to pass search criteria and
have them handled correctly but unfortunately also mean that small
changes may be required to existing code that uses IMAPClient.</p>
<section id="search-criteria">
<h3>Search criteria<a class="headerlink" href="#search-criteria" title="Permalink to this heading">¶</a></h3>
<p>The preferred way to specify criteria now is as a list of strings,
ints and dates (where relevant). The list should be flat with all the
criteria parts run together. Where a criteria takes an argument, just
provide it as the next element in the list.</p>
<p>Some valid examples:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;DELETED&#39;</span><span class="p">])</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;NOT&#39;</span><span class="p">,</span> <span class="s1">&#39;DELETED&#39;</span><span class="p">])</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;FLAGGED&#39;</span><span class="p">,</span> <span class="s1">&#39;SUBJECT&#39;</span><span class="p">,</span> <span class="s1">&#39;foo&#39;</span><span class="p">,</span> <span class="s1">&#39;BODY&#39;</span><span class="p">,</span> <span class="s1">&#39;hello world&#39;</span><span class="p">])</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;NOT&#39;</span><span class="p">,</span> <span class="s1">&#39;DELETED&#39;</span><span class="p">,</span> <span class="s1">&#39;SMALLER&#39;</span><span class="p">,</span> <span class="mi">1000</span><span class="p">])</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;SINCE&#39;</span><span class="p">,</span> <span class="n">date</span><span class="p">(</span><span class="mi">2006</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span> <span class="mi">3</span><span class="p">)])</span>
</pre></div>
</div>
<p>IMAPClient will perform all required conversion, quoting and
encoding. Callers do not need to and should not attempt to do this
themselves. IMAPClient will automatically send criteria parts as IMAP
literals when required (i.e. when the encoded part is 8-bit).</p>
<p>Some previously accepted ways of passing search criteria will not work
as they did in previous versions of IMAPClient. Small changes will be
required in these cases.  Here are some examples of how to update code
written against older versions of IMAPClient:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;NOT DELETED&#39;</span><span class="p">])</span>    <span class="c1"># Before</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;NOT&#39;</span><span class="p">,</span> <span class="s1">&#39;DELETED&#39;</span><span class="p">])</span> <span class="c1"># After</span>

<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;TEXT &quot;foo&quot;&#39;</span><span class="p">])</span>     <span class="c1"># Before</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;TEXT&#39;</span><span class="p">,</span> <span class="s1">&#39;foo&#39;</span><span class="p">])</span>    <span class="c1"># After (IMAPClient will add the quotes)</span>

<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;DELETED&#39;</span><span class="p">,</span> <span class="s1">&#39;TEXT &quot;foo&quot;&#39;</span><span class="p">])</span>    <span class="c1"># Before</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;DELETED&#39;</span><span class="p">,</span> <span class="s1">&#39;TEXT&#39;</span><span class="p">,</span> <span class="s1">&#39;foo&#39;</span><span class="p">])</span>   <span class="c1"># After</span>

<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;SMALLER 1000&#39;</span><span class="p">])</span>    <span class="c1"># Before</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;SMALLER&#39;</span><span class="p">,</span> <span class="mi">1000</span><span class="p">])</span>   <span class="c1"># After</span>
</pre></div>
</div>
<p>It is also possible to pass a single string as the search
criteria. IMAPClient will not attempt quoting in this case, allowing
the caller to specify search criteria at a lower level. Specifying
criteria using a sequence of strings is preferable however. The
following examples (equivalent to those further above) are valid:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="s1">&#39;DELETED&#39;</span><span class="p">)</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="s1">&#39;NOT DELETED&#39;</span><span class="p">)</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="s1">&#39;FLAGGED SUBJECT &quot;foo&quot; BODY &quot;hello world&quot;&#39;</span><span class="p">)</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="s1">&#39;NOT DELETED SMALLER 1000&#39;</span><span class="p">)</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="s1">&#39;SINCE 03-May-2006&#39;</span><span class="p">)</span>
</pre></div>
</div>
</section>
<section id="search-charset">
<h3>Search charset<a class="headerlink" href="#search-charset" title="Permalink to this heading">¶</a></h3>
<p>The way that the search <em>charset</em> argument is handled has also
changed.</p>
<p>Any unicode criteria arguments will now be encoded by IMAPClient using
the supplied charset. The charset must refer to an encoding that is
capable of handling the criteria’s characters or an error will
occur. The charset must obviously also be one that the server
supports! (UTF-8 is common)</p>
<p>Any criteria given as bytes will not be changed by IMAPClient, but the
provided charset will still be passed to the IMAP server. This allows
already encoding criteria to be passed through as-is. The encoding
referred to by <em>charset</em> should match the actual encoding used for the
criteria.</p>
<p>The following are valid examples:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="s1">&#39;TEXT&#39;</span><span class="p">,</span> <span class="sa">u</span><span class="s1">&#39;</span><span class="se">\u263a</span><span class="s1">&#39;</span><span class="p">],</span> <span class="s1">&#39;utf-8&#39;</span><span class="p">)</span>         <span class="c1"># IMAPClient will apply UTF-8 encoding</span>
<span class="n">c</span><span class="o">.</span><span class="n">search</span><span class="p">([</span><span class="sa">b</span><span class="s1">&#39;TEXT&#39;</span><span class="p">,</span> <span class="sa">b</span><span class="s1">&#39;</span><span class="se">\xe2\x98\xba</span><span class="s1">&#39;</span><span class="p">],</span> <span class="s1">&#39;utf-8&#39;</span><span class="p">)</span>  <span class="c1"># Caller has already applied UTF-8 encoding</span>
</pre></div>
</div>
<p>The documentation and tests for search, gmail_search, sort and thread
has updated to account for these changes and have also been generally
improved.</p>
</section>
</section>
<section id="socket-timeout-support-new">
<h2>Socket timeout support [NEW]<a class="headerlink" href="#socket-timeout-support-new" title="Permalink to this heading">¶</a></h2>
<p>IMAPClient now accepts a timeout at creation time. The timeout applies
while establishing the connection and for all operations on the socket
connected to the IMAP server.</p>
</section>
<section id="semantic-versioning">
<h2>Semantic versioning<a class="headerlink" href="#semantic-versioning" title="Permalink to this heading">¶</a></h2>
<p>In order to better indicate version compatibility to users, IMAPClient
will now strictly adhere to the <a class="reference external" href="http://semver.org">Semantic Versioning</a> scheme.</p>
</section>
<section id="performance-optimisation-for-parsing-message-id-lists">
<h2>Performance optimisation for parsing message id lists<a class="headerlink" href="#performance-optimisation-for-parsing-message-id-lists" title="Permalink to this heading">¶</a></h2>
<p>A short circuit is now used when parsing a list of message ids which
greatly speeds up parsing time.</p>
</section>
<section id="other">
<h2>Other<a class="headerlink" href="#other" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Perform quoting of Gmail labels. Thanks to Pawel Sz for the fix.</p></li>
<li><p>The type of the various flag constants was fixed. Thanks to Thomi
Richards for pointing this out.</p></li>
<li><p>Now using mock 1.3.0. Thanks to Thomi Richards for the patch.</p></li>
<li><p>Fixed handling of very long numeric only folder names. Thanks to
Paweł Gorzelany for the patch.</p></li>
<li><p>The default charset for gmail_search is now UTF-8. This makes it
easier to use any unicode string as a search string and is safe
because Gmail supports UTF-8 search criteria.</p></li>
<li><p>PEP8 compliance fixed (except for some occasional long lines)</p></li>
<li><p>Added a “shutdown” method.</p></li>
<li><p>The embedded six package has been removed in favour of using an
externally installed instance.</p></li>
<li><p>Fixed handling of literals in STATUS responses.</p></li>
<li><p>Only use the untagged post-login CAPABILITY response once (if sent
by server).</p></li>
<li><p>Release history made part of the main documentation.</p></li>
<li><p>Clarified how message ids work in the docs.</p></li>
<li><p>Livetest infrastructure now works with Yahoo’s OAUTH2</p></li>
<li><p>Fixed bytes handling in Address.__str__</p></li>
</ul>
</section>
</section>
<section id="version-0-13">
<h1>Version 0.13<a class="headerlink" href="#version-0-13" title="Permalink to this heading">¶</a></h1>
<section id="added-support-for-the-id-command-new">
<h2>Added support for the ID command [NEW]<a class="headerlink" href="#added-support-for-the-id-command-new" title="Permalink to this heading">¶</a></h2>
<p>As per RFC2971. Thanks to Eben Freeman from Nylas.</p>
</section>
<section id="fix-exception-with-nil-address-in-envelope-address-list">
<h2>Fix exception with NIL address in envelope address list<a class="headerlink" href="#fix-exception-with-nil-address-in-envelope-address-list" title="Permalink to this heading">¶</a></h2>
<p>Thanks to Thomas Steinacher for this fix.</p>
</section>
<section id="fixed-handling-of-nil-in-search-response">
<h2>Fixed handling of NIL in SEARCH response<a class="headerlink" href="#fixed-handling-of-nil-in-search-response" title="Permalink to this heading">¶</a></h2>
<p>Fixed a regression in the handling of NIL/None SEARCH
responses. Thanks again to Thomas Steinacher.</p>
</section>
<section id="date-parsing-fixes">
<h2>Date parsing fixes<a class="headerlink" href="#date-parsing-fixes" title="Permalink to this heading">¶</a></h2>
<p>Don’t traceback when an unparsable date is seen in ENVELOPE
responses. None is returned instead.</p>
<p>Support quirky timestamp strings which use dots for the time
separator.</p>
<p>Removed horrible INTERNALDATE parsing code (use parse_to_datetime
instead).</p>
<p>datetime_to_imap has been moved to the datetime_util module and is now
called datetime_to_INTERNALDATE. This will only affect you in the
unlikely case that you were importing this function out of the
IMAPClient package.</p>
</section>
<section id="id18">
<h2>Other<a class="headerlink" href="#id18" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>The docs for various IMAPClient methods, and the HACKING.rst file
have been updated.</p></li>
<li><p>CONDSTORE live test is now more reliable (especially when running
against Gmail)</p></li>
</ul>
</section>
</section>
<section id="version-0-12">
<h1>Version 0.12<a class="headerlink" href="#version-0-12" title="Permalink to this heading">¶</a></h1>
<section id="fixed-unicode-handling-api-change">
<h2>Fixed unicode handling [API CHANGE]<a class="headerlink" href="#fixed-unicode-handling-api-change" title="Permalink to this heading">¶</a></h2>
<p>During the work to support Python 3, IMAPClient was changed to do
return unicode for most responses. This was a bad decision, especially
because it effectively breaks content that uses multiple encodings
(e.g. RFC822 responses). This release includes major changes so that
most responses are returned as bytes (Python 3) or str (Python
2). This means that correct handling of response data is now possible
by code using IMAPClient.</p>
<p>Folder name handling has also been cleaned up as part of this work. If
the <code class="docutils literal notranslate"><span class="pre">folder_encode</span></code> attribute is <code class="docutils literal notranslate"><span class="pre">True</span></code> (the default) then folder
names will <strong>always</strong> be returned as unicode. If <code class="docutils literal notranslate"><span class="pre">folder_encode</span></code> is
False then folder names will always be returned as bytes/strs.</p>
<p>Code using IMAPClient will most likely need to be updated to account
these unicode handling changes.</p>
<p>Many thanks to Inbox (now Nilas, <a class="reference external" href="https://nilas.com/">https://nilas.com/</a>) for sponsoring this
work.</p>
</section>
<section id="extra-init-keyword-args-are-passed-through-new">
<h2>Extra __init__ keyword args are passed through [NEW]<a class="headerlink" href="#extra-init-keyword-args-are-passed-through-new" title="Permalink to this heading">¶</a></h2>
<p>Any unused keyword arguments passed to the IMAPClient initialiser will
now be passed through to the underlying imaplib IMAP4, IMAP4_SSL or
IMAP4_stream class. This is specifically to allow the use of imaplib
features that control certificate validation (if available with the
version of Python being used).</p>
<p>Thanks to Chris Arndt for this change.</p>
</section>
<section id="modseq-parts-in-search-responses-are-now-handled">
<h2>MODSEQ parts in SEARCH responses are now handled<a class="headerlink" href="#modseq-parts-in-search-responses-are-now-handled" title="Permalink to this heading">¶</a></h2>
<p>If the CONDSTORE extension is supported by a server and a MODSEQ
criteria was used with search(), a TypeError could occur. This has now
been fixed and the MODSEQ value returned by the server is now
available via an attribute on the returned list of ids.</p>
</section>
<section id="minor-changes">
<h2>Minor Changes<a class="headerlink" href="#minor-changes" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Small tweaks to support Python 3.4.</p></li>
<li><p>The deprecated get_folder_delimiter() method has been removed.</p></li>
<li><p>More control over OAUTH2 parameters. Thanks to Phil Peterson for
this.</p></li>
<li><p>Fixed livetest/interact OAUTH handling under Python 3.</p></li>
</ul>
</section>
</section>
<section id="version-0-11-1">
<h1>Version 0.11.1<a class="headerlink" href="#version-0-11-1" title="Permalink to this heading">¶</a></h1>
<ul class="simple">
<li><p>Close folders during livetest cleanup so that livetests work with
newer Dovecot servers (#131)</p></li>
</ul>
</section>
<section id="version-0-11">
<h1>Version 0.11<a class="headerlink" href="#version-0-11" title="Permalink to this heading">¶</a></h1>
<section id="support-for-raw-gmail-searching-new">
<h2>Support for raw Gmail searching [NEW]<a class="headerlink" href="#support-for-raw-gmail-searching-new" title="Permalink to this heading">¶</a></h2>
<p>The new gmail_search methods allows direct Gmail queries using the
X-GM-RAW search extension. Thanks to John Louis del Rosario for the
patch.</p>
</section>
<section id="envelope-fetch-response-parsing-new-api-change">
<h2>ENVELOPE FETCH response parsing [NEW, API CHANGE]<a class="headerlink" href="#envelope-fetch-response-parsing-new-api-change" title="Permalink to this heading">¶</a></h2>
<p>ENVELOPE FETCH responses are now returned as Envelope instances. These
objects are namedtuples providing convenient attribute and positional
based access to envelope fields. The Date field is also now converted
to a datetime instance.</p>
<p>As part of this change various date and time related utilities were
moved to a new module at imapclient.datetime_util.</p>
<p>Thanks to Naveen Nathan for the work on this feature.</p>
</section>
<section id="correct-nested-bodystructure-handling-api-change">
<h2>Correct nested BODYSTRUCTURE handling [API CHANGE]<a class="headerlink" href="#correct-nested-bodystructure-handling-api-change" title="Permalink to this heading">¶</a></h2>
<p>BODY and BODYSTRUCTURE responses are now processed recusively so
multipart sections within other multipart sections are returned
correctly. This also means that each the part of the response now has
a is_multipart property available.</p>
<p>NOTE: code that expects the old (broken) behaviour will need to be
updated.</p>
<p>Thanks to Brandon Rhodes for the bug report.</p>
</section>
<section id="select-response-bug-fix">
<h2>SELECT response bug fix<a class="headerlink" href="#select-response-bug-fix" title="Permalink to this heading">¶</a></h2>
<p>Handle square brackets in flags returned in SELECT response.
Previously these would cause parsing errors. Thanks to Benjamin
Morrise for the bug report.</p>
</section>
<section id="id19">
<h2>Minor Changes<a class="headerlink" href="#id19" title="Permalink to this heading">¶</a></h2>
<p>Copyright date update for 2014.</p>
</section>
</section>
<section id="version-0-10-2">
<h1>Version 0.10.2<a class="headerlink" href="#version-0-10-2" title="Permalink to this heading">¶</a></h1>
<p>Switch back to setuptools now that distribute and setuptools have
merged back. Some users were reporting problems with distribute and
the newer versions of setuptools.</p>
</section>
<section id="version-0-10-1">
<h1>Version 0.10.1<a class="headerlink" href="#version-0-10-1" title="Permalink to this heading">¶</a></h1>
<p>Fixed regressions in several cases when binary data (i.e. normal
strings under Python 2) are used as arguments to some methods. Also
refactored input normalisation functions somewhat.</p>
<p>Fixed buggy method for extracting flags and Gmail labels from STORE
responses.</p>
</section>
<section id="version-0-10">
<h1>Version 0.10<a class="headerlink" href="#version-0-10" title="Permalink to this heading">¶</a></h1>
<section id="python-3-support-22-api-change">
<h2>Python 3 support (#22) [API CHANGE]<a class="headerlink" href="#python-3-support-22-api-change" title="Permalink to this heading">¶</a></h2>
<p>Python 3.2 and 3.3 are now officially supported. This release also
means that Python versions older than 2.6 are no longer supported.</p>
<p>A single source approach has been used, with no conversion step required.</p>
<p>A big thank you to Mathieu Agopian for his massive contribution to
getting the Python 3 port finished. His changes and ideas feature
heavily in this release.</p>
<p><strong>IMPORTANT</strong>: Under Python 2, all strings returned by IMAPClient are now
returned as unicode objects. With the exception of folder names, these
unicode objects will only contain characters in the ASCII range so
this shouldn’t break existing code, however there is always a chance
that there will be a problem. Please test your existing applications
thoroughly with this verison of IMAPClient before deploying to
production situations.</p>
</section>
<section id="id20">
<h2>Minor Changes<a class="headerlink" href="#id20" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>“python setup.py test” now runs the unit tests</p></li>
<li><p>Mock library is now longer included (listed as external test dependency)</p></li>
<li><p>live tests that aren’t UID related are now only run once</p></li>
<li><p>live tests now perform far less logins to the server under test</p></li>
<li><p>Unit tests can now be run for all supported Python versions using <code class="docutils literal notranslate"><span class="pre">tox</span></code>.</p></li>
<li><p>Improved documentation regarding working on the project.</p></li>
<li><p>Many documentation fixes and improvements.</p></li>
</ul>
</section>
<section id="minor-bug-fixes">
<h2>Minor Bug Fixes<a class="headerlink" href="#minor-bug-fixes" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>HIGHESTMODSEQ in SELECT response is now parsed correctly</p></li>
<li><p>Fixed daylight saving handling in FixedOffset class</p></li>
<li><p>Fixed –port command line bug in imapclient.interact when SSL
connections are made.</p></li>
</ul>
</section>
</section>
<section id="version-0-9-2">
<h1>Version 0.9.2<a class="headerlink" href="#version-0-9-2" title="Permalink to this heading">¶</a></h1>
<section id="thread-support-new">
<h2>THREAD support [NEW]<a class="headerlink" href="#thread-support-new" title="Permalink to this heading">¶</a></h2>
<p>The IMAP THREAD command is now supported. Thanks to Lukasz Mierzwa for
the patches.</p>
</section>
<section id="enhanced-capability-querying-new">
<h2>Enhanced capability querying [NEW]<a class="headerlink" href="#enhanced-capability-querying-new" title="Permalink to this heading">¶</a></h2>
<p>Previously only the pre-authentication server capabilities were
returned by the capabilities() method. Now, if the connection is
authenticated, the post-authentication capabilities will be returned.
If the server sent an untagged CAPABILITY response after authentication,
that will be used, avoiding an unnecessary CAPABILITY command call.</p>
<p>All this ensures that the client sees all available server
capabilities.</p>
</section>
<section id="minor-features">
<h2>Minor Features<a class="headerlink" href="#minor-features" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Better documentation for contributers (see HACKING file)</p></li>
<li><p>Copyright date update for 2013.</p></li>
</ul>
</section>
</section>
<section id="version-0-9-1">
<h1>Version 0.9.1<a class="headerlink" href="#version-0-9-1" title="Permalink to this heading">¶</a></h1>
<section id="stream-support-new">
<h2>Stream support [NEW]<a class="headerlink" href="#stream-support-new" title="Permalink to this heading">¶</a></h2>
<p>It is now possible to have IMAPClient run an external command to
establish a connection to the IMAP server via a new <em>stream</em> keyword
argument to the initialiser. This is useful for exotic connection or
authentication setups. The <em>host</em> argument is used as the command to
run.</p>
<p>Thanks to Dave Eckhardt for the original patch.</p>
</section>
<section id="oauth2-support-new">
<h2>OAUTH2 Support [NEW]<a class="headerlink" href="#oauth2-support-new" title="Permalink to this heading">¶</a></h2>
<p>OAUTH2 authentication (as supported by Gmail’s IMAP) is now available
via the new oauth2_login method. Thanks to Zac Witte for the original
patch.</p>
</section>
<section id="livetest-now-handles-gmail-s-new-message-handling">
<h2>livetest now handles Gmail’s new message handling<a class="headerlink" href="#livetest-now-handles-gmail-s-new-message-handling" title="Permalink to this heading">¶</a></h2>
<p>Gmail’s IMAP implementation recently started requiring a NOOP command
before new messages become visible after delivery or an APPEND. The
livetest suite has been updated to deal with this.</p>
</section>
</section>
<section id="version-0-9">
<h1>Version 0.9<a class="headerlink" href="#version-0-9" title="Permalink to this heading">¶</a></h1>
<section id="gmail-label-support">
<h2>Gmail Label Support<a class="headerlink" href="#gmail-label-support" title="Permalink to this heading">¶</a></h2>
<p>New methods have been added for interacting with Gmail’s label API:
get_gmail_labels, add_gmail_labels, set_gmail_labels,
remove_gmail_labels. Thanks to Brian Neal for the patches.</p>
</section>
<section id="removed-code-duplication-9">
<h2>Removed Code Duplication (#9)<a class="headerlink" href="#removed-code-duplication-9" title="Permalink to this heading">¶</a></h2>
<p>A signficant amount of duplicated code has been removed by abstracting
out common command handling code. This will make the Python 3 port and
future maintenance easier.</p>
</section>
<section id="livetest-can-now-be-run-against-non-dummy-accounts-108">
<h2>livetest can now be run against non-dummy accounts (#108)<a class="headerlink" href="#livetest-can-now-be-run-against-non-dummy-accounts-108" title="Permalink to this heading">¶</a></h2>
<p>Up until this release the tests in imapclient.livetest could only be
run against a dummy IMAP account (all data in the account would be
lost during testing). The tests are now limited to a sub-folder
created by the tests so it is ok to run them against an account that
contains real messages. These messages will be left alone.</p>
</section>
<section id="id21">
<h2>Minor Features<a class="headerlink" href="#id21" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Don’t traceback when an IMAP server returns a all-digit folder name
without quotes. Thanks to Rhett Garber for the bug report. (#107)</p></li>
<li><p>More tests for ACL related methods (#89)</p></li>
<li><p>More tests for namespace()</p></li>
<li><p>Added test for read-only select_folder()</p></li>
</ul>
</section>
<section id="id22">
<h2>Minor Bug Fixes<a class="headerlink" href="#id22" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>Fixed rename live test so that it uses folder namespaces (#100).</p></li>
<li><p>Parse STATUS responses robustly - fixes folder_status() with MS
Exchange.</p></li>
<li><p>Numerous livetest fixes to work around oddities with the MS
Exchange IMAP implementation.</p></li>
</ul>
</section>
</section>
<section id="version-0-8-1">
<h1>Version 0.8.1<a class="headerlink" href="#version-0-8-1" title="Permalink to this heading">¶</a></h1>
<ul class="simple">
<li><p>IMAPClient wasn’t installing on Windows due to an extra trailing
slash in MANIFEST.in (#102). This is a bug in distutils.</p></li>
<li><p>MANIFEST.in was fixed so that the main documentation index file
is included the source distribution.</p></li>
<li><p>distribute_setup.py was updated to the 0.6.24 version.</p></li>
<li><p>This release also contains some small documentation fixes.</p></li>
</ul>
</section>
<section id="version-0-8">
<h1>Version 0.8<a class="headerlink" href="#version-0-8" title="Permalink to this heading">¶</a></h1>
<section id="oauth-support-54-new">
<h2>OAUTH Support (#54) [NEW]<a class="headerlink" href="#oauth-support-54-new" title="Permalink to this heading">¶</a></h2>
<p>OAUTH authentication is now supported using the oauth_login
method. This requires the 3rd party oauth2 package is
installed. Thanks to Johannes Heckel for contributing the patch to
this.</p>
</section>
<section id="idle-support-50-new">
<h2>IDLE Support (#50) [NEW]<a class="headerlink" href="#idle-support-50-new" title="Permalink to this heading">¶</a></h2>
<p>The IDLE extension is now supported through the new idle(),
idle_check() and idle_done() methods. See the example in
imapclient/examples/idle_example.py.</p>
</section>
<section id="noop-support-74-new">
<h2>NOOP Support (#74) [NEW]<a class="headerlink" href="#noop-support-74-new" title="Permalink to this heading">¶</a></h2>
<p>The NOOP command is now supported. It returns parsed untagged server
responses in the same format as idle_check() and idle_done().</p>
</section>
<section id="sphinx-based-docs-5-new">
<h2>Sphinx Based Docs (#5) [NEW]<a class="headerlink" href="#sphinx-based-docs-5-new" title="Permalink to this heading">¶</a></h2>
<p>Full documentation is now available under doc/html in the source
distribution and at <a class="reference external" href="http://imapclient.readthedocs.io/">http://imapclient.readthedocs.io/</a> online.</p>
</section>
<section id="added-rename-folder-77-new">
<h2>Added rename_folder (#77) [NEW]<a class="headerlink" href="#added-rename-folder-77-new" title="Permalink to this heading">¶</a></h2>
<p>Renaming of folders was an obvious omission!</p>
</section>
<section id="id23">
<h2>Minor Features<a class="headerlink" href="#id23" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>interact.py can now read livetest.py INI files (#66)</p></li>
<li><p>interact.py can now embed shells from ipython 0.10 and 0.11 (#98)</p></li>
<li><p>interact.py and livetest.py are now inside the imapclient package so
they can be used even when IMAClient has been installed from PyPI
(#82)</p></li>
<li><p>Added “debug” propety and setting of a log file (#90)</p></li>
<li><p>“normalise_times” attribute allows caller to select whether
datetimes returned by fetch() are native or not (#96) (Thanks Andrew
Scheller)</p></li>
<li><p>Added imapclient.version_info - a tuple that contains the IMAPClient
version number broken down into it’s parts.</p></li>
</ul>
</section>
<section id="id24">
<h2>Minor Bug Fixes<a class="headerlink" href="#id24" title="Permalink to this heading">¶</a></h2>
<ul class="simple">
<li><p>getacl() was using wrong lexing class (#85) (Thanks josephhh)</p></li>
<li><p>Removed special handling for response tuples without whitespace
between them.  Post-process BODY/BODYSTRUCTURE responses
instead. This should not affect the external API. (#91) (Thanks
daishi)</p></li>
<li><p>Fix incorrect msg_id for UID fetch when use_uid is False (#99)</p></li>
</ul>
</section>
</section>
<section id="version-0-7">
<h1>Version 0.7<a class="headerlink" href="#version-0-7" title="Permalink to this heading">¶</a></h1>
<section id="body-and-bodystructure-parsing-fixes-58-api-change">
<h2>BODY and BODYSTRUCTURE parsing fixes (#58) [API CHANGE]<a class="headerlink" href="#body-and-bodystructure-parsing-fixes-58-api-change" title="Permalink to this heading">¶</a></h2>
<p>The response values for BODY and BODYSTRUCTURE responses may include a
sequence of tuples which are not separated by whitespace. These should
be treated as a single item (a list of multiple arbitrarily nested
tuples) but IMAPClient was treating them as separate items. IMAPClient
now returns these tuples in a list to allow for consistent parsing.</p>
<p>A BODYSTRUCTURE response for a multipart email with 2 parts would have
previously looked something like this:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="p">((</span><span class="s1">&#39;text&#39;</span><span class="p">,</span> <span class="s1">&#39;html&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s1">&#39;charset&#39;</span><span class="p">,</span> <span class="s1">&#39;us-ascii&#39;</span><span class="p">),</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="s1">&#39;quoted-printable&#39;</span><span class="p">,</span> <span class="mi">55</span><span class="p">,</span> <span class="mi">3</span><span class="p">),</span>
 <span class="p">(</span><span class="s1">&#39;text&#39;</span><span class="p">,</span> <span class="s1">&#39;plain&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s1">&#39;charset&#39;</span><span class="p">,</span> <span class="s1">&#39;us-ascii&#39;</span><span class="p">),</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="s1">&#39;7bit&#39;</span><span class="p">,</span> <span class="mi">26</span><span class="p">,</span> <span class="mi">1</span><span class="p">),</span>
 <span class="s1">&#39;mixed&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s1">&#39;boundary&#39;</span><span class="p">,</span> <span class="s1">&#39;===============1534046211==&#39;</span><span class="p">))</span>
</pre></div>
</div>
<p>The response is now returned like this:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="p">([</span>
   <span class="p">(</span><span class="s1">&#39;text&#39;</span><span class="p">,</span> <span class="s1">&#39;html&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s1">&#39;charset&#39;</span><span class="p">,</span> <span class="s1">&#39;us-ascii&#39;</span><span class="p">),</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="s1">&#39;quoted-printable&#39;</span><span class="p">,</span> <span class="mi">55</span><span class="p">,</span> <span class="mi">3</span><span class="p">),</span>
   <span class="p">(</span><span class="s1">&#39;text&#39;</span><span class="p">,</span> <span class="s1">&#39;plain&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s1">&#39;charset&#39;</span><span class="p">,</span> <span class="s1">&#39;us-ascii&#39;</span><span class="p">),</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="s1">&#39;7bit&#39;</span><span class="p">,</span> <span class="mi">26</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
 <span class="p">],</span>
 <span class="s1">&#39;mixed&#39;</span><span class="p">,</span> <span class="p">(</span><span class="s1">&#39;boundary&#39;</span><span class="p">,</span> <span class="s1">&#39;===============1534046211==&#39;</span><span class="p">))</span>
</pre></div>
</div>
<p>The behaviour for single part messages is unchanged. In this case the
first element of the tuple is a string specifying the major content
type of the message (eg “text”).</p>
<p>An is_multipart boolean property now exists on BODY and BODYSTRUCTURE
responses to allow the caller to easily determine whether the response
is for a multipart message.</p>
<p>Code that expects the previous response handling behaviour needs to be
updated.</p>
</section>
<section id="live-tests-converted-to-use-unittest2-4">
<h2>Live tests converted to use unittest2 (#4)<a class="headerlink" href="#live-tests-converted-to-use-unittest2-4" title="Permalink to this heading">¶</a></h2>
<p>livetest.py now uses the unittest2 package to run the tests. This
provides much more flexibility that the custom approach that was used
before. Dependencies between tests are gone - each test uses a fresh
IMAP connection and is preceeded by the same setup.</p>
<p>unittest2.main() is used to provide a number of useful command line
options and the ability to run a subset of tests.</p>
<p>IMAP account parameters are now read using a configuration file
instead of command line arguments. See livetest-sample.ini for an
example.</p>
</section>
<section id="added-namespace-support-63-api-change">
<h2>Added NAMESPACE support (#63) [API CHANGE]<a class="headerlink" href="#added-namespace-support-63-api-change" title="Permalink to this heading">¶</a></h2>
<p>namespace() method added and get_folder_delimiter() has been
deprecated.</p>
</section>
<section id="added-support-for-fetch-modifiers-62-new">
<h2>Added support for FETCH modifiers (#62) [NEW]<a class="headerlink" href="#added-support-for-fetch-modifiers-62-new" title="Permalink to this heading">¶</a></h2>
<p>The fetch method now takes optional modifiers as the last
argument. These are required for extensions such as RFC 4551
(conditional store). Thanks to Thomas Jost for the patch.</p>
</section>
</section>
<section id="version-0-6-2">
<h1>Version 0.6.2<a class="headerlink" href="#version-0-6-2" title="Permalink to this heading">¶</a></h1>
<section id="square-brackets-in-responses-now-parsed-correctly-55">
<h2>Square brackets in responses now parsed correctly (#55)<a class="headerlink" href="#square-brackets-in-responses-now-parsed-correctly-55" title="Permalink to this heading">¶</a></h2>
<p>This fixes response handling for FETCH items such as
<code class="docutils literal notranslate"><span class="pre">BODY[HEADER.FIELDS</span> <span class="pre">(from</span> <span class="pre">subject)]</span></code>.</p>
</section>
<section id="example-moved-56">
<h2>Example moved (#56)<a class="headerlink" href="#example-moved-56" title="Permalink to this heading">¶</a></h2>
<p>The example has been moved to imapclient/examples directory and is
included when the IMAPClient is installed from PyPI.</p>
</section>
<section id="distribute-57">
<h2>Distribute (#57)<a class="headerlink" href="#distribute-57" title="Permalink to this heading">¶</a></h2>
<p>The project is now packaged using Distribute instead of
setuptools. There should be no real functional change.</p>
</section>
</section>
<section id="version-0-6-1">
<h1>Version 0.6.1<a class="headerlink" href="#version-0-6-1" title="Permalink to this heading">¶</a></h1>
<section id="python-ssl-bug-patch">
<h2>Python SSL bug patch<a class="headerlink" href="#python-ssl-bug-patch" title="Permalink to this heading">¶</a></h2>
<p>Automatically patch a bug in imaplib which can cause hangs when using
SSL (Python Issue 5949). The patch is only applied when the running
Python version is known to be affected by the problem.</p>
</section>
<section id="doc-update">
<h2>Doc update<a class="headerlink" href="#doc-update" title="Permalink to this heading">¶</a></h2>
<p>Updated the README to better reflect the current state of the project.</p>
</section>
</section>
<section id="version-0-6">
<h1>Version 0.6<a class="headerlink" href="#version-0-6" title="Permalink to this heading">¶</a></h1>
<section id="new-response-parser-1-45">
<h2>New response parser (#1, #45)<a class="headerlink" href="#new-response-parser-1-45" title="Permalink to this heading">¶</a></h2>
<p>Command response lexing and parsing code rewritten from stratch to
deal with various bugs that surfaced when dealing with more complex
responses (eg. BODYSTRUCTURE and ENVELOPE). This change also fixes
various problems when interacting with Gmail and MS Exchange.</p>
</section>
<section id="xlist-extension-support-25-new">
<h2>XLIST extension support (#25) [NEW]<a class="headerlink" href="#xlist-extension-support-25-new" title="Permalink to this heading">¶</a></h2>
<p>Where the server supports it, xlist_folders() will return a mapping of
various common folder names to the actual server folder names. Gmail’s
IMAP server supports this.</p>
</section>
<section id="added-copy-command-support-36-new">
<h2>Added COPY command support (#36) [NEW]<a class="headerlink" href="#added-copy-command-support-36-new" title="Permalink to this heading">¶</a></h2>
<p>New copy() method.</p>
</section>
<section id="added-interact-py-new">
<h2>Added interact.py [NEW]<a class="headerlink" href="#added-interact-py-new" title="Permalink to this heading">¶</a></h2>
<p>A script for interactive IMAPClient sessions. Useful for debugging and
exploration. Uses IPython if installed.</p>
</section>
<section id="full-select-response-24-api-change">
<h2>Full SELECT response (#24) [API CHANGE]<a class="headerlink" href="#full-select-response-24-api-change" title="Permalink to this heading">¶</a></h2>
<p>select_folder() now returns a dictionary with the full (parsed) SELECT
command response instead of just the message count.</p>
</section>
<section id="full-list-responses-24-api-change">
<h2>Full list responses (#24) [API CHANGE]<a class="headerlink" href="#full-list-responses-24-api-change" title="Permalink to this heading">¶</a></h2>
<p>The return value from list_folders(), list_sub_folders() and
xlist_folders() now include the IMAP folder flags and delimiter.</p>
</section>
<section id="folder-name-character-encoding-21-api-change">
<h2>Folder name character encoding (#21) [API CHANGE]<a class="headerlink" href="#folder-name-character-encoding-21-api-change" title="Permalink to this heading">¶</a></h2>
<p>Bytes that are greater than 0x7f in folder names are will cause an
exception when passed to methods that accept folder name arguments
because there is no unambigous way to handle these. Callers should
encode such folder names to unicode objects first.</p>
<p>Folder names are now always returned as unicode objects.</p>
</section>
<section id="message-sequence-number-now-always-returned-in-fetch-responses">
<h2>Message sequence number now always returned in FETCH responses<a class="headerlink" href="#message-sequence-number-now-always-returned-in-fetch-responses" title="Permalink to this heading">¶</a></h2>
<p>Fetch responses now include a “SEQ” element which gives the message
(non-UID) sequence number. This allows for easy mapping between UIDs
and standard sequence IDs.</p>
</section>
<section id="folder-name-handling-fixes-28-42">
<h2>Folder name handling fixes (#28, #42)<a class="headerlink" href="#folder-name-handling-fixes-28-42" title="Permalink to this heading">¶</a></h2>
<p>Various folder name handling bugs fixed.</p>
</section>
</section>
<section id="version-0-5-2">
<h1>Version 0.5.2<a class="headerlink" href="#version-0-5-2" title="Permalink to this heading">¶</a></h1>
<section id="folder-name-quoting-and-escaping-fixes-28">
<h2>Folder name quoting and escaping fixes (#28)<a class="headerlink" href="#folder-name-quoting-and-escaping-fixes-28" title="Permalink to this heading">¶</a></h2>
<p>Correctly handle double quotes and backslashes in folder names when
parsing LIST and LSUB responses.</p>
</section>
<section id="fixed-fetch-literal-handling-33">
<h2>Fixed fetch literal handling (#33)<a class="headerlink" href="#fixed-fetch-literal-handling-33" title="Permalink to this heading">¶</a></h2>
<p>Fixed problem with parsing responses where a literal followed another
literal.</p>
</section>
</section>
<section id="version-0-5-1">
<h1>Version 0.5.1<a class="headerlink" href="#version-0-5-1" title="Permalink to this heading">¶</a></h1>
<section id="license-change">
<h2>License change<a class="headerlink" href="#license-change" title="Permalink to this heading">¶</a></h2>
<p>Changed license from GPL to new BSD.</p>
</section>
</section>
<section id="version-0-5">
<h1>Version 0.5<a class="headerlink" href="#version-0-5" title="Permalink to this heading">¶</a></h1>
<section id="ssl-support">
<h2>SSL support<a class="headerlink" href="#ssl-support" title="Permalink to this heading">¶</a></h2>
<p>Support for SSL based connections by passing ssl=True when
constructing an IMAPClient instance.</p>
</section>
<section id="transparent-folder-encoding">
<h2>Transparent folder encoding<a class="headerlink" href="#transparent-folder-encoding" title="Permalink to this heading">¶</a></h2>
<p>Folder names are now encoded and decoded transparently if required
(using modified UTF-7). This means that any methods that return folder
names may return unicode objects as well as normal strings [API
CHANGE]. Additionally, any method that takes a folder name now accepts
unicode object too. Use the folder_encode attribute to control whether
encode/decoding is performed.</p>
</section>
<section id="unquoted-folder-name-handling-fix">
<h2>Unquoted folder name handling fix<a class="headerlink" href="#unquoted-folder-name-handling-fix" title="Permalink to this heading">¶</a></h2>
<p>Unquoted folder names in server responses are now handled
correctly. Thanks to Neil Martinsen-Burrell for reporting this bug.</p>
</section>
<section id="fixed-handling-of-unusual-characters-in-folder-names">
<h2>Fixed handling of unusual characters in folder names<a class="headerlink" href="#fixed-handling-of-unusual-characters-in-folder-names" title="Permalink to this heading">¶</a></h2>
<p>Fixed a bug with handling of unusual characters in folder names.</p>
</section>
<section id="timezone-handling-api-change">
<h2>Timezone handling [API CHANGE]<a class="headerlink" href="#timezone-handling-api-change" title="Permalink to this heading">¶</a></h2>
<p>Timezones are now handled correctly for datetimes passed as input and for
server responses. This fixes a number of bugs with timezones. Returned
datetimes are always in the client’s local timezone.</p>
</section>
<section id="more-unit-tests">
<h2>More unit tests<a class="headerlink" href="#more-unit-tests" title="Permalink to this heading">¶</a></h2>
<p>Many more unit tests added, some using Michael Foord’s excellent
mock.py.  (<a class="reference external" href="http://www.voidspace.org.uk/python/mock/">http://www.voidspace.org.uk/python/mock/</a>)</p>
</section>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <div>
    <h3><a href="index.html">Table of Contents</a></h3>
    <ul>
<li><a class="reference internal" href="#">Version 2.3.0</a></li>
<li><a class="reference internal" href="#version-2-2-0">Version 2.2.0</a></li>
<li><a class="reference internal" href="#version-2-1-0">Version 2.1.0</a></li>
<li><a class="reference internal" href="#version-2-0">Version 2.0</a></li>
<li><a class="reference internal" href="#version-1-1-0">Version 1.1.0</a></li>
<li><a class="reference internal" href="#version-1-0-2">Version 1.0.2</a></li>
<li><a class="reference internal" href="#version-1-0-1">Version 1.0.1</a></li>
<li><a class="reference internal" href="#version-1-0-0">Version 1.0.0</a></li>
<li><a class="reference internal" href="#version-0-13">Version 0.13</a></li>
<li><a class="reference internal" href="#version-0-12">Version 0.12</a></li>
<li><a class="reference internal" href="#version-0-11-1">Version 0.11.1</a></li>
<li><a class="reference internal" href="#version-0-11">Version 0.11</a></li>
<li><a class="reference internal" href="#version-0-10-2">Version 0.10.2</a></li>
<li><a class="reference internal" href="#version-0-10-1">Version 0.10.1</a></li>
<li><a class="reference internal" href="#version-0-10">Version 0.10</a></li>
<li><a class="reference internal" href="#version-0-9-2">Version 0.9.2</a></li>
<li><a class="reference internal" href="#version-0-9-1">Version 0.9.1</a></li>
<li><a class="reference internal" href="#version-0-9">Version 0.9</a></li>
<li><a class="reference internal" href="#version-0-8-1">Version 0.8.1</a></li>
<li><a class="reference internal" href="#version-0-8">Version 0.8</a></li>
<li><a class="reference internal" href="#version-0-7">Version 0.7</a></li>
<li><a class="reference internal" href="#version-0-6-2">Version 0.6.2</a></li>
<li><a class="reference internal" href="#version-0-6-1">Version 0.6.1</a></li>
<li><a class="reference internal" href="#version-0-6">Version 0.6</a></li>
<li><a class="reference internal" href="#version-0-5-2">Version 0.5.2</a></li>
<li><a class="reference internal" href="#version-0-5-1">Version 0.5.1</a></li>
<li><a class="reference internal" href="#version-0-5">Version 0.5</a></li>
</ul>

  </div>
  <div>
    <h4>Previous topic</h4>
    <p class="topless"><a href="contributing.html"
                          title="previous chapter">Contributing to IMAPClient</a></p>
  </div>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/releases.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a></li>
        <li class="right" >
          <a href="contributing.html" title="Contributing to IMAPClient"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">IMAPClient 2.3.1 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Version 2.3.0</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2014, Menno Smits.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 5.0.2.
    </div>
  </body>
</html>